<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_image_color_convert.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>vx_tutorial_image_color_convert.c File Reference</h1><hr/><a name="_details"></a><h2>Introduction</h2>
<p>Convert image from RGB format to NV12 format then extract luma channel</p>
<p>In this tutorial we learn the below concepts,</p>
<ul>
<li>How to create OpenVX context, OpenVX image data object and OpenVX virtual image data object</li>
<li>How to read a BMP file and load the pixel values into the image data object</li>
<li>How to query the image data object for attributes like width, height</li>
<li>How to create OpenVX node and associate it with previously created graph</li>
<li>How to schedule OpenVX graph for execution then execute the graph</li>
<li>How to query the node data object for attributes like width, height</li>
<li>How to query the graph data object for attributes like number of nodes and parameters</li>
<li>How to read pixel values from an image data object and save it as a BMP file</li>
<li>How to cleanup all created resources and exit the OpenVX application</li>
</ul>
<p>To include OpenVX interfaces include below file </p>
<div class="fragment"><pre class="fragment"><span class="preprocessor"> #include &lt;VX/vx.h&gt;</span>
</pre></div><p>Follow the comments in the function <a class="el" href="vx__tutorial__image__color__convert_8c.html#ad2b8fd09b4afa65ad14e89f0a9513f11" title="Tutorial Entry Point.">vx_tutorial_image_color_convert()</a> to understand this tutorial</p>
<p>As part of this tutorial, we create few utility functions as listed below. These functions will be used in subsequent tutorials to display node and graph attributes. </p>
<table frame="box" rules="all" cellspacing="0" width="50%" border="1" cellpadding="3">
<tr bgcolor="lightgrey">
<th><p>Utility function  </p>
</th><th><p>Description   </p>
</th></tr>
<tr>
<td><p><a class="el" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes()</a>  </p>
</td><td><p>Displays attributes of a previously created graph. <b>NOTE:</b> This function though listed in this tutorial is used in later tutorials   </p>
</td></tr>
<tr>
<td><p><a class="el" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes()</a>  </p>
</td><td><p>Displays attributes of a previously created node. <b>NOTE:</b> This function though listed in this tutorial is used in later tutorials   </p>
</td></tr>
</table>

<p>Definition in file <a class="el" href="vx__tutorial__image__color__convert_8c_source.html">vx_tutorial_image_color_convert.c</a>.</p>

<p><a href="vx__tutorial__image__color__convert_8c_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__image__color__convert_8c.html#a8118656bb5a60090a1dbffa402168438">IN_FILE_NAME</a>&nbsp;&nbsp;&nbsp;&quot;colors.bmp&quot;</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Input file name.  <a href="#a8118656bb5a60090a1dbffa402168438"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__image__color__convert_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a>&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_image_color_convert_out.bmp&quot;</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Output file name.  <a href="#a75506823f0db0ef3f4f022cf132dbbbb"></a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__image__color__convert_8c.html#ad2b8fd09b4afa65ad14e89f0a9513f11">vx_tutorial_image_color_convert</a> ()</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Tutorial Entry Point.  <a href="#ad2b8fd09b4afa65ad14e89f0a9513f11"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__image__color__convert_8c.html#a86ae0d04d187710cc2d10f85bccb6e5d">show_graph_attributes</a> (vx_graph graph)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Show attributes of previously created graph.  <a href="#a86ae0d04d187710cc2d10f85bccb6e5d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__image__color__convert_8c.html#a4576aae15198e9645228f21be4290cff">show_node_attributes</a> (vx_node node)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Show attributes of previously created node.  <a href="#a4576aae15198e9645228f21be4290cff"></a><br/></td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="a8118656bb5a60090a1dbffa402168438"></a><!-- doxytag: member="vx_tutorial_image_color_convert.c::IN_FILE_NAME" ref="a8118656bb5a60090a1dbffa402168438" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define IN_FILE_NAME&nbsp;&nbsp;&nbsp;&quot;colors.bmp&quot;</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Input file name. </p>

<p>Definition at line <a class="el" href="vx__tutorial__image__color__convert_8c_source.html#l00117">117</a> of file <a class="el" href="vx__tutorial__image__color__convert_8c_source.html">vx_tutorial_image_color_convert.c</a>.</p>

</div>
</div>
<a class="anchor" id="a75506823f0db0ef3f4f022cf132dbbbb"></a><!-- doxytag: member="vx_tutorial_image_color_convert.c::OUT_FILE_NAME" ref="a75506823f0db0ef3f4f022cf132dbbbb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define OUT_FILE_NAME&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_image_color_convert_out.bmp&quot;</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Output file name. </p>

<p>Definition at line <a class="el" href="vx__tutorial__image__color__convert_8c_source.html#l00120">120</a> of file <a class="el" href="vx__tutorial__image__color__convert_8c_source.html">vx_tutorial_image_color_convert.c</a>.</p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ad2b8fd09b4afa65ad14e89f0a9513f11"></a><!-- doxytag: member="vx_tutorial_image_color_convert.c::vx_tutorial_image_color_convert" ref="ad2b8fd09b4afa65ad14e89f0a9513f11" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void vx_tutorial_image_color_convert </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Tutorial Entry Point. </p>

<p><ul>
<li>Define objects that we wish to create in the OpenVX application.</li>
</ul>
<p>A vx_context object is defined which is used as input parameter for all subesquent OpenVX object create APIs </p>
<div class="fragment"><pre class="fragment">     */
    vx_context context;
    vx_image rgb_image = NULL;
    vx_image nv12_image = NULL;
    vx_image y_image = NULL;
    vx_node node0 = NULL, node1 = NULL;
    vx_graph graph = NULL;
</pre></div><ul>
<li>Create OpenVX context.</li>
</ul>
<p>This MUST be done first before any OpenVX API call. The context that is returned is used as input for subsequent OpenVX APIs </p>
<div class="fragment"><pre class="fragment">     */
    context = vxCreateContext();
</pre></div><ul>
<li>Create OpenVX graph.</li>
</ul>
<div class="fragment"><pre class="fragment">     */
    graph = vxCreateGraph(context);
</pre></div><ul>
<li>Create image object.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file()</a> to see how a vx_image object is created and filled with RGB data from BMP file <a class="el" href="vx__tutorial__graph__user__kernel__pytiovx_8c.html#a8118656bb5a60090a1dbffa402168438">IN_FILE_NAME</a> </p>
<div class="fragment"><pre class="fragment">     */
    rgb_image = <a class="code" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file</a>(context, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>, vx_false_e);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(rgb_image);
</pre></div><ul>
<li>Create OpenVX virtual image object.</li>
</ul>
<p>Creates an OpenVX virtual image object of 'width' x 'height' and having data format 'df'. Virtual images are allowed to have a value of 0 for width and height.</p>
<div class="fragment"><pre class="fragment">     */
    nv12_image = vxCreateVirtualImage(graph, 0, 0, VX_DF_IMAGE_NV12);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(nv12_image);
</pre></div><ul>
<li>Create OpenVX image object.</li>
</ul>
<p>Creates an OpenVX image object of 'width' x 'height' and having data format 'df'. </p>
<div class="fragment"><pre class="fragment">     */
    y_image = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
</pre></div><ul>
<li>Create OpenVX node object.</li>
</ul>
<p>Creates an OpenVX Color Convert node with rgb_image input and nv12_image output.</p>
<div class="fragment"><pre class="fragment">     */
    node0 = vxColorConvertNode(graph, rgb_image, nv12_image);
</pre></div><ul>
<li>Create OpenVX node object.</li>
</ul>
<p>Creates an OpenVX Channel Combine node with nv12_image input and y_image output. It extracts the channel VX_CHANNEL_Y from input image.</p>
<div class="fragment"><pre class="fragment">     */
    node1 = vxChannelExtractNode(graph, nv12_image, VX_CHANNEL_Y, y_image);
</pre></div><ul>
<li>Verify graph object.</li>
</ul>
<p>Verifies that all parameters of graph object are valid.</p>
<div class="fragment"><pre class="fragment">     */
    status = vxVerifyGraph(graph);
</pre></div><ul>
<li>Show graph attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes()</a> to see how graph attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
</pre></div><ul>
<li>Show node attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes()</a> to see how node attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node0);
    <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node1);
</pre></div><ul>
<li>Schedule graph.</li>
</ul>
<p>Schedules graph for future execution. vxVerifyGraph must return VX_SUCCESS before this function will pass.</p>
<div class="fragment"><pre class="fragment">         */
        vxScheduleGraph(graph);
</pre></div><ul>
<li>Wait graph.</li>
</ul>
<p>Waits for graph to complete.</p>
<div class="fragment"><pre class="fragment">         */
        vxWaitGraph(graph);
</pre></div><ul>
<li>Show graph attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes()</a> to see how graph attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">         */
        <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
</pre></div><ul>
<li>Show node attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes()</a> to see how node attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">         */
        <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node0);
        <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node1);
</pre></div><ul>
<li>Save image object to bitmap file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a>.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file()</a> to see how data in vx_image object is accessed to store pixel values from the image object to BMP file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a> </p>
<div class="fragment"><pre class="fragment">         */
        <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>, y_image);
</pre></div><ul>
<li>Release image object.</li>
</ul>
<p>Since we are done with using this image object, release it </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseImage(&amp;rgb_image);
    vxReleaseImage(&amp;nv12_image);
    vxReleaseImage(&amp;y_image);
</pre></div><ul>
<li>Release node object.</li>
</ul>
<p>Since we are done with using this node object, release it </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseNode(&amp;node0);
    vxReleaseNode(&amp;node1);
</pre></div><ul>
<li>Release graph object.</li>
</ul>
<p>Since we are done with using this graph object, release it </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseGraph(&amp;graph);
</pre></div><ul>
<li>Release context object.</li>
</ul>
<p>Since we are done using OpenVX context, release it. No further OpenVX API calls should be done, until a context is again created using vxCreateContext() </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseContext(&amp;context);
</pre></div> </p>

<p>Definition at line <a class="el" href="vx__tutorial__image__color__convert_8c_source.html#l00125">125</a> of file <a class="el" href="vx__tutorial__image__color__convert_8c_source.html">vx_tutorial_image_color_convert.c</a>.</p>

</div>
</div>
<a class="anchor" id="a86ae0d04d187710cc2d10f85bccb6e5d"></a><!-- doxytag: member="vx_tutorial_image_color_convert.c::show_graph_attributes" ref="a86ae0d04d187710cc2d10f85bccb6e5d" args="(vx_graph graph)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void show_graph_attributes </td>
          <td>(</td>
          <td class="paramtype">vx_graph&nbsp;</td>
          <td class="paramname"> <em>graph</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Show attributes of previously created graph. </p>
<p>This function queries the vx_graph graph for its number of nodes, number of parameters, state, performance, reference name and reference count then prints this information.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>graph</em>&nbsp;</td><td>[in] Previouly created graph object </td></tr>
  </table>
  </dd>
</dl>

<p><ul>
<li>Query graph attributes.</li>
</ul>
<p>Queries graph for number of nodes, number of parameters, state and performance</p>
<div class="fragment"><pre class="fragment">     */
    vxQueryGraph(graph, VX_GRAPH_NUMNODES, &amp;num_nodes, <span class="keyword">sizeof</span>(vx_uint32));
    vxQueryGraph(graph, VX_GRAPH_NUMPARAMETERS, &amp;num_params, <span class="keyword">sizeof</span>(vx_uint32));
    vxQueryGraph(graph, VX_GRAPH_STATE, &amp;state, <span class="keyword">sizeof</span>(vx_enum));
    vxQueryGraph(graph, VX_GRAPH_PERFORMANCE, &amp;perf, <span class="keyword">sizeof</span>(vx_perf_t));
</pre></div> </p>

<p>Definition at line <a class="el" href="vx__tutorial__image__color__convert_8c_source.html#l00399">399</a> of file <a class="el" href="vx__tutorial__image__color__convert_8c_source.html">vx_tutorial_image_color_convert.c</a>.</p>

</div>
</div>
<a class="anchor" id="a4576aae15198e9645228f21be4290cff"></a><!-- doxytag: member="vx_tutorial_image_color_convert.c::show_node_attributes" ref="a4576aae15198e9645228f21be4290cff" args="(vx_node node)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void show_node_attributes </td>
          <td>(</td>
          <td class="paramtype">vx_node&nbsp;</td>
          <td class="paramname"> <em>node</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Show attributes of previously created node. </p>
<p>This function queries the vx_node node for its status, number of parameters, performance, reference name and reference count then prints this information.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>node</em>&nbsp;</td><td>[in] Previouly created graph object </td></tr>
  </table>
  </dd>
</dl>

<p><ul>
<li>Query node attributes.</li>
</ul>
<p>Queries node for number of status, number of parameters and performance</p>
<div class="fragment"><pre class="fragment">     */
    vxQueryNode(node, VX_NODE_STATUS, &amp;status, <span class="keyword">sizeof</span>(vx_status));
    vxQueryNode(node, VX_NODE_PARAMETERS, &amp;num_params, <span class="keyword">sizeof</span>(vx_uint32));
    vxQueryNode(node, VX_NODE_PERFORMANCE, &amp;perf, <span class="keyword">sizeof</span>(vx_perf_t));
</pre></div> </p>

<p>Definition at line <a class="el" href="vx__tutorial__image__color__convert_8c_source.html#l00470">470</a> of file <a class="el" href="vx__tutorial__image__color__convert_8c_source.html">vx_tutorial_image_color_convert.c</a>.</p>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
